#include "all.h"
void parallax1(short scrollSpeedX, short scrollSpeedY)
{
	scrollSpeedX = scrollSpeedX;
	scrollSpeedY = scrollSpeedY;
}

// intended for parallax scrolling
// perform other tile effects as well
void parallax_normal(short scrollSpeedX, short scrollSpeedY)
{
	short shiftx = scrollSpeedX >> 1;
	short shifty = (scrollSpeedY >> 1);

	while (shiftx < 0)
		shiftx += 16;
	while (shifty < 0)
		shifty += 16;

	if (shifty > 0) {
		short *pxtiles = (short *) tiles;
		short buf[32];
		short i;
		shifty = 16 - shifty;
		// left column
		for (i = 0; i < 8; ++i) {
			buf[i] = pxtiles[i];
			buf[i + 8] = pxtiles[i + 16];
			buf[i + 16] = pxtiles[i];
			buf[i + 24] = pxtiles[i + 16];
		}
		for (i = 0; i < 8; ++i) {
			pxtiles[i] = buf[i + shifty];
			pxtiles[i + 16] = buf[i + shifty + 8];
		}
		// right column
		for (i = 0; i < 8; ++i) {
			buf[i] = pxtiles[i + 8];
			buf[i + 8] = pxtiles[i + 24];
			buf[i + 16] = pxtiles[i + 8];
			buf[i + 24] = pxtiles[i + 24];
		}
		for (i = 0; i < 8; ++i) {
			pxtiles[i + 8] = buf[i + shifty];
			pxtiles[i + 24] = buf[i + shifty + 8];
		}
	}

	if (shiftx == 0)
		return;
      asm("move.l %0,%%a0;" "move.w %1,%%d0;" "move.w #15,%%d1;" "0:" "move.b (%%a0),%%d2;" "lsl.w #8,%%d2;" "move.b (%%a0,16),%%d2;" "ror.w %%d0,%%d2;" "move.b %%d2,(%%a0,16);" "lsr.w #8,%%d2;" "move.b %%d2,(%%a0);" "move.b (%%a0,32),%%d2;" "lsl.w #8,%%d2;" "move.b (%%a0,48),%%d2;" "ror.w %%d0,%%d2;" "move.b %%d2,(%%a0,48);" "lsr.w #8,%%d2;" "move.b %%d2,(%%a0,32);" "addq.l #1,%%a0;" "dbra %%d1,0b;": :"g"(tiles),
	    "g"
	    (shiftx));

}


/*
// intended for parallax scrolling
// perform other tile effects as well
void parallax_down(short scrollSpeedX, short scrollSpeedY)
{

	short shifty=0;
	if(scrollSpeedY<0) shifty=1-(scrollSpeedY >> 1);
	if(scrollSpeedY>0) shifty=(scrollSpeedY >> 1)+1;
	else shifty = 2;
	while (shifty < 0)
		shifty += 16;
	if (shifty > 0) {
		short *pxtiles = (short *) tiles;
		short buf[32];
		short i;
		shifty = 16 - shifty;
		// left column
		for (i = 0; i < 8; ++i) {
			buf[i] = pxtiles[i];
			buf[i + 8] = pxtiles[i + 16];
			buf[i + 16] = pxtiles[i];
			buf[i + 24] = pxtiles[i + 16];
		}
		for (i = 0; i < 8; ++i) {
			pxtiles[i] = buf[i + shifty];
			pxtiles[i + 16] = buf[i + shifty + 8];
		}
		// right column
		for (i = 0; i < 8; ++i) {
			buf[i] = pxtiles[i + 8];
			buf[i + 8] = pxtiles[i + 24];
			buf[i + 16] = pxtiles[i + 8];
			buf[i + 24] = pxtiles[i + 24];
		}
		for (i = 0; i < 8; ++i) {
			pxtiles[i + 8] = buf[i + shifty];
			pxtiles[i + 24] = buf[i + shifty + 8];
		}
	}

scrollSpeedX = scrollSpeedX;

}
*/
// intended for parallax scrolling
// perform other tile effects as well
void parallax_downright(short scrollSpeedX, short scrollSpeedY)
{
	short shiftx = 0;
	if (scrollSpeedX < 0)
		shiftx = 1 - (scrollSpeedX >> 1);
	if (scrollSpeedX > 0)
		shiftx = (scrollSpeedX >> 1) + 1;
	else
		shiftx = 1;	//2

	short shifty = 0;
	if (scrollSpeedY < 0)
		shifty = 1 - (scrollSpeedY >> 1);
	if (scrollSpeedY > 0)
		shifty = (scrollSpeedY >> 1) + 1;
	else
		shifty = 1;	//2

	while (shiftx < 0)
		shiftx += 16;
	while (shifty < 0)
		shifty += 16;

	if (shifty > 0) {
		short *pxtiles = (short *) tiles;
		short buf[32];
		short i;
		shifty = 16 - shifty;
		// left column
		for (i = 0; i < 8; ++i) {
			buf[i] = pxtiles[i];
			buf[i + 8] = pxtiles[i + 16];
			buf[i + 16] = pxtiles[i];
			buf[i + 24] = pxtiles[i + 16];
		}
		for (i = 0; i < 8; ++i) {
			pxtiles[i] = buf[i + shifty];
			pxtiles[i + 16] = buf[i + shifty + 8];
		}
		// right column
		for (i = 0; i < 8; ++i) {
			buf[i] = pxtiles[i + 8];
			buf[i + 8] = pxtiles[i + 24];
			buf[i + 16] = pxtiles[i + 8];
			buf[i + 24] = pxtiles[i + 24];
		}
		for (i = 0; i < 8; ++i) {
			pxtiles[i + 8] = buf[i + shifty];
			pxtiles[i + 24] = buf[i + shifty + 8];
		}
	}

	if (shiftx == 0)
		return;
      asm("move.l %0,%%a0;" "move.w %1,%%d0;" "move.w #15,%%d1;" "0:" "move.b (%%a0),%%d2;" "lsl.w #8,%%d2;" "move.b (%%a0,16),%%d2;" "ror.w %%d0,%%d2;" "move.b %%d2,(%%a0,16);" "lsr.w #8,%%d2;" "move.b %%d2,(%%a0);" "move.b (%%a0,32),%%d2;" "lsl.w #8,%%d2;" "move.b (%%a0,48),%%d2;" "ror.w %%d0,%%d2;" "move.b %%d2,(%%a0,48);" "lsr.w #8,%%d2;" "move.b %%d2,(%%a0,32);" "addq.l #1,%%a0;" "dbra %%d1,0b;": :"g"(tiles),
	    "g"
	    (shiftx));
}



// intended for parallax scrolling
// perform other tile effects as well

void parallax6(short scrollSpeedX, short scrollSpeedY)
{
//      short i;
	short a;
	static short watermove = 0;
	if (watermove > 3 || watermove < 0)
		watermove = 0;
	//long buf;
	watermove++;
	if (watermove == 3) {

		watermove = 0;
		char buf[16];
		char *water = (char *) (tiles + 0x0C40);
		for (a = 0; a < 16; a++) {
			*(buf + a) = *(water + a);
		}
		for (a = 0; a < 16; a++) {
			*(water + a) = *(water + a + 16);
			*(water + 16 + a) = *(water + a + 32);
			*(water + 32 + a) = *(water + a + 48);
			*(water + 48 + a) = *(buf + a);
		}

	}
//unused
	scrollSpeedX = scrollSpeedX;
	scrollSpeedY = scrollSpeedY;
}
